/*
*/

import java.applet.*;
import java.io.*;

// vrml.* package
import vrml.*;
import vrml.field.*;
import vrml.node.*;

public class 
CylinderJS extends Script 
{

  private static final boolean DEBUG = true;

  CylinderUI ui;

  private Browser             browser        = null;
  private SFNode              rootNode       = null;
  private SFNode       addChildren    = null;
  private SFNode       removeChildren = null;
  private SFNode                myNode       = null;
  private Node                myTransform[]  = null;

  /**
  */
  public void 
  initialize()
  {
     if(DEBUG==true) System.out.println("after initialize() handle ");
     ui = new CylinderUI(this);     

     // ** Now it is time to get the handle of browser
     browser = (Browser) getBrowser();
     if(DEBUG==true) System.out.println("after browser handle ");
         
     //try 
    // {
         if(DEBUG==true) System.out.println("before rootNode handle ");
       rootNode = (SFNode) getField("CYLINDER");
         if(DEBUG==true) System.out.println("after rootNode handle ");
      
     // } catch (InvalidNodeException e)
     //   { System.out.println("Invalid Node Exception"); }
      

      // Get EventIns of the rootNode
      addChildren = (SFNode) ((Node)rootNode.getValue()).getEventIn("addChildren");
      removeChildren = (SFNode) ((Node)rootNode.getValue()).getEventIn("removeChildren");
      
      if(DEBUG == true ) System.out.println(" events are registered !! ");
   
      addChildrenNode(1.0f, 1.0f, true , true, true, true );

  }

  /**
  */
  public void
  updateShape(float Cheight, float Cradius, boolean Cbottom, boolean Ctop,
              boolean Cside, boolean Dragging)
  {

     if(DEBUG)
     {
        System.out.println(" Height :"+Cheight);
        System.out.println(" Radius :"+Cradius);
        System.out.println(" Bottom :"+Cbottom);
        System.out.println(" Top    :"+Ctop);
        System.out.println(" Side   :"+Cside);
        System.out.println(" Drag   :"+Dragging);

     }// end of if

     removeChildren.setValue(myNode);
     addChildrenNode(Cheight, Cradius, Cbottom, Ctop, Cside, Dragging);
     
  }// end of updateShape()

  /**
  */
  void
  addChildrenNode(float Cheight, float Cradius, boolean Cbottom, boolean Ctop,
                  boolean Cside, boolean Dragging)
  {
   
     if(DEBUG==true) 
          System.out.println(" height is "+Cheight+" radius "+Cradius+
                             " bottom i s "+Cbottom+ " top is "+Ctop+
                             " side is "+Cside+" Moving is "+Dragging);
          
     String vrmlString = "Group { children [ DEF myCone Transform { "+
                         "children [ Shape { appearance Appearance { "+
                         "material Material {} } geometry Cylinder {"+
                         " radius "+Cradius+" height "+Cheight+
                         " bottom "+(Cbottom==true?"TRUE":"FALSE")+
                         " top "+(Ctop==true?"TRUE":"FALSE")+
                         " side "+(Cside==true?"TRUE":"FALSE")+" } } ] }"+
                          (Dragging==true?" DEF Sensor PlaneSensor { } ] ROUTE Sensor.translation_changed TO myCone.set_translation }": " DEF Sensor SphereSensor { } ] ROUTE Sensor.rotation_changed TO myCone.set_rotation } ");
        
     try 
     {
        BaseNode bn[] = browser.createVrmlFromString(vrmlString);

        myNode.setValue(bn[0]);
        addChildren.setValue(myNode);

     } catch(InvalidVRMLSyntaxException ivse)
       { }
      
   }// end of addChildrenNode()


}
